org.pentaho.reporting.libraries.resourceloader

## Interface ResourceManagerBackend

All Known Implementing Classes:
  DefaultResourceManagerBackend

    public interface ResourceManagerBackend

Todo: Document Me

Author:
  Thomas Morgner

### Method Summary

Methods
`Resource` `create(ResourceManager frontEnd, ResourceData key, ResourceKey context, java.lang.Class[] target)`
`ResourceKey` `createKey(java.lang.Object data, java.util.Map parameters)`
`ResourceKey` `deriveKey(ResourceKey parent, java.lang.String path, java.util.Map parameters)`
`ResourceKey` `deserialize(ResourceKey bundleKey, java.lang.String serializedKey)`
`boolean` `isResourceUnchanged(ResourceManager resourceManager, Resource resource)`
`ResourceData` `loadRawData(ResourceManager frontEnd, ResourceKey key)`
`ResourceBundleData` `loadResourceBundle(ResourceManager frontEnd, ResourceKey key)`
`void` `registerBundleLoader(ResourceBundleLoader loader)`
`void` `registerDefaultFactories()`
`void` `registerDefaultLoaders()`
`void` `registerFactory(ResourceFactory factory)`
`void` `registerLoader(ResourceLoader loader)`
`java.lang.String` `serialize(ResourceKey bundleKey, ResourceKey key)`
`java.net.URL` `toURL(ResourceKey key)`

### Method Detail

#### createKey

    ResourceKey createKey(java.lang.Object data,
                        java.util.Map parameters)
                          throws ResourceKeyCreationException

Throws:
  `ResourceKeyCreationException`

#### deriveKey

    ResourceKey deriveKey(ResourceKey parent,
                        java.lang.String path,
                        java.util.Map parameters)
                          throws ResourceKeyCreationException

Throws:
  `ResourceKeyCreationException`

#### toURL

    java.net.URL toURL(ResourceKey key)

#### create

    Resource create(ResourceManager frontEnd,
                  ResourceData key,
                  ResourceKey context,
                  java.lang.Class[] target)
                    throws ResourceLoadingException,
                           ResourceCreationException

Throws:
  `ResourceLoadingException`
  `ResourceCreationException`

#### loadResourceBundle

    ResourceBundleData loadResourceBundle(ResourceManager frontEnd,
                                        ResourceKey key)
                                          throws ResourceLoadingException

Throws:
  `ResourceLoadingException`

#### registerDefaultFactories

    void registerDefaultFactories()

#### registerDefaultLoaders

    void registerDefaultLoaders()

#### registerBundleLoader

    void registerBundleLoader(ResourceBundleLoader loader)

#### registerLoader

    void registerLoader(ResourceLoader loader)

#### registerFactory

    void registerFactory(ResourceFactory factory)

#### loadRawData

    ResourceData loadRawData(ResourceManager frontEnd,
                           ResourceKey key)
                             throws ResourceLoadingException,
                                    UnrecognizedLoaderException

Throws:
  `ResourceLoadingException`
  `UnrecognizedLoaderException`

#### isResourceUnchanged

    boolean isResourceUnchanged(ResourceManager resourceManager,
                              Resource resource)
                                throws ResourceLoadingException

Throws:
  `ResourceLoadingException`

#### serialize

    java.lang.String serialize(ResourceKey bundleKey,
                             ResourceKey key)
                               throws ResourceException

Throws:
  `ResourceException`

#### deserialize

    ResourceKey deserialize(ResourceKey bundleKey,
                          java.lang.String serializedKey)
                            throws ResourceKeyCreationException

Throws:
  `ResourceKeyCreationException`